//
//  ViewController.m
//  tableView多项选择删除
//
//  Created by greenTea on 16/6/1.
//  Copyright © 2016年 greenTea. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
@property (nonatomic,strong) NSMutableArray *dataList;
@property (nonatomic,strong) NSMutableDictionary *selectedDic;
@property (weak, nonatomic) IBOutlet UITableView *tableView2;
- (IBAction)editAction:(UIBarButtonItem *)sender;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.automaticallyAdjustsScrollViewInsets = NO;
    // Do any additional setup after loading the view, typically from a nib.
}
#pragma mark - UITableViewDelegate UITableViewDataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.dataList.count;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *identifier = @"cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];
    if (cell==nil) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifier];
    }
    if (indexPath.row<=self.dataList.count) {
        cell.textLabel.text = self.dataList[indexPath.row];
    }
    return cell;
}
//编辑样式

-(UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath

{
    return UITableViewCellEditingStyleDelete | UITableViewCellEditingStyleInsert;
}

//添加一项

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath

{
    if (tableView.editing) {
        [self.selectedDic setObject:indexPath forKey:self.dataList[indexPath.row]];
    }
}

//取消一项

- (void)tableView:(UITableView *)tableView didDeselectRowAtIndexPath:(NSIndexPath *)indexPath

{
    if (tableView.editing) {
        [self.selectedDic removeObjectForKey:self.dataList[indexPath.row]];
    }
}
//删除员工
-(void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath{
    if (indexPath.row <= [self.dataList count]) {
        
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationAutomatic];
    }
    
}

-(NSMutableArray*)dataList{
    if (_dataList==nil) {
        _dataList = [[NSMutableArray alloc]init];
        for (int i=0; i<50; i++) {
            [_dataList addObject:[NSString stringWithFormat:@"%i",i]];
        }
    }
    return _dataList;
}
-(NSMutableDictionary*)selectedDic{
    if (_selectedDic==nil) {
        _selectedDic = [[NSMutableDictionary alloc]init];
    }
    return _selectedDic;
}

- (IBAction)editAction:(UIBarButtonItem *)sender {
    [self.tableView2 setEditing:!self.tableView2.editing animated:YES];
    if (self.tableView2.editing) {
        [self.navigationItem.rightBarButtonItem setTitle:@"删除"];
    }
    else{
        [self.navigationItem.rightBarButtonItem setTitle:@"编辑"];
        if (self.selectedDic.count>0) {
            NSArray *array = [self.selectedDic allKeys];
            [self.dataList removeObjectsInArray:array];
            [self.tableView2 deleteRowsAtIndexPaths:[NSArray arrayWithArray:[self.selectedDic allValues]] withRowAnimation:UITableViewRowAnimationFade];
           
            [self.selectedDic removeAllObjects];
        }
    }
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
